SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 19:23'!
aCatalogEmpty

	^ Dictionary new .! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 19:24'!
aCatalogNotEmpty
	
	|aCatalog aProduct1 aProduct2 aProduct3 aProduct4|
	 aCatalog := self aCatalogEmpty .
	
	aProduct1 := Product newWithAnID: 'isbn12234-14252-15252-152512' andAPrice: 12.
	aProduct2 := Product newWithAnID: 'isbn12234-14252-15252-152513' andAPrice: 1.
	aProduct3 := Product newWithAnID: 'isbn12234-14252-15252-152514' andAPrice: 21.
	aProduct4 := Product newWithAnID: 'isbn12234-14252-15252-152515' andAPrice: 22.
		
	"TENDRIAMOS QUE REIFICAR LA MONDA"
	aCatalog at: (aProduct1 itemID) put: aProduct1.
	aCatalog at: (aProduct2 itemID) put: aProduct2.
	aCatalog at: (aProduct3 itemID) put: aProduct3.
	aCatalog at: (aProduct4 itemID) put: aProduct4.
	
	^ aCatalog ! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 19:26'!
aProductInTheCatalog

	| aProductId |
	
	aProductId := self aCatalogNotEmpty keys at: 1.
	
	^ self aCatalogNotEmpty at: aProductId.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/18/2012 00:32'!
aProductNotInTheCatalog

	^ Product newWithAnID: 'isbn12234-14252-15252-152555' andAPrice: 34.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 18:50'!
cartManager
	
	| cartManager |
	
	cartManager := CartManager new.
	
	^ cartManager .
	! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'ExequielGomez 6/22/2012 23:37'!
givenAFinalCart: aCart andAFinalCashier: aCashier shouldHaveTheProducts: allProducts andTheCash: finalCashAvailable andTheSalesBook: finalSalesBook andAnAmountOfTransactionsShouldBe: amountOfTransaction

	self assert: ( aCart products = allProducts ).
	self assert: ( finalCashAvailable = aCashier cashAvailable).
	self assert: ( finalSalesBook = (aCashier salesBook)).
	self assert: ( amountOfTransaction = (aCashier merchantProcessorInternalInterface) amountOfTransactions)! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/18/2012 00:32'!
otherProductInTheCatalog

	^ Product newWithAnID: 'isbn12234-14252-15252-152514' andAPrice: 21.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/24/2012 20:28'!
saleBookOf: aCashier shouldBeLike: salesBookBeforeCheckOut andContainTheNewProducts: productsBeforeCheckOut boughtWith: aCreditCardNumber

	| salesBookAfterCheckOut |
.	salesBookAfterCheckOut := aCashier salesBook.
	
	salesBookAfterCheckOut keysAndValuesDo:[ :key :value |
		|isTheRecentClient isAOldDescription isADescriptionAlreadyBought|
			
		isTheRecentClient :=  (key = (aCreditCardNumber)).
		isAOldDescription := (isTheRecentClient not) and: [(salesBookBeforeCheckOut at: key) = value].
		isADescriptionAlreadyBought := 
		isTheRecentClient and: 
			[ 
				(
					(
						( salesBookBeforeCheckOut includesKey: key ) not
					) 
					or: 
					[ value includesAllOf: 
						(salesBookBeforeCheckOut at: key)
					]
				) 
				and: 
				[ value anySatisfy:
					[ :sale | sale contains: productsBeforeCheckOut]
				]
			].
			self assert: (isADescriptionAlreadyBought or: [ isAOldDescription]).
	].! !

!TusLibrosTest methodsFor: 'cartTests' stamp: 'PaneroGomez 6/16/2012 16:10'!
test01CartShouldBeEmptyWhenCreated

	| aCart |
	
	aCart := Cart newWithCatalog: (self aCatalogNotEmpty).
	
	self assert: ( aCart isEmpty ).! !

!TusLibrosTest methodsFor: 'cartTests' stamp: 'PaneroGomez 6/19/2012 20:42'!
test02CartShouldNotBeEmptyWhenAddAnElement

	| aCart aProduct|
	
	aCart := Cart newWithCatalog: self aCatalogNotEmpty.
	aProduct := self aProductInTheCatalog.
	aCart addProduct: aProduct.
	
	self deny: aCart isEmpty! !

!TusLibrosTest methodsFor: 'cartTests' stamp: 'PaneroGomez 6/18/2012 00:36'!
test03TwoEqualProductsCanBeAddedToTheCart

	|aCart aProduct otherProduct aCatalog|
	
	aCatalog := self aCatalogNotEmpty.
	
	aProduct  := self aProductInTheCatalog .
	otherProduct  := aProduct copy.
	
	aCart := Cart newWithCatalog: aCatalog.
	aCart addProduct: aProduct .
	aCart addProduct: otherProduct .

	self assert: ( aProduct = otherProduct  and: [aCart size = 2]).! !

!TusLibrosTest methodsFor: 'cartTests' stamp: 'PaneroGomez 6/18/2012 00:37'!
test04WhenAskAProductQuantityOfADontAddedProductShouldReturnZero
  
	|aCart aProduct otherProduct aCatalog|
	
	aCatalog := self aCatalogNotEmpty.
	
	aProduct  := self aProductInTheCatalog .
	otherProduct  := self otherProductInTheCatalog .
	
	aCart := Cart newWithCatalog: aCatalog.
	aCart addProduct: aProduct .

	self assert: ( (aCart quantityOf: otherProduct) = 0).! !

!TusLibrosTest methodsFor: 'cartTests' stamp: 'PaneroGomez 6/18/2012 00:37'!
test05WhenAskForAProductQuantityShouldReturnTheQuantityAdded
  
	|aCart aProduct otherProduct aCatalog|
	
	aCatalog := self aCatalogNotEmpty.
	
	aProduct  := self aProductInTheCatalog .
	otherProduct  := aProduct copy.
	
	aCart := Cart newWithCatalog: aCatalog.
	aCart addProduct: aProduct .
	aCart addProduct: otherProduct .

	self assert: ( (aCart quantityOf: aProduct) = 2).
	self assert: ( (aCart quantityOf: otherProduct) = 2).! !

!TusLibrosTest methodsFor: 'cartTests' stamp: 'PaneroGomez 6/18/2012 00:38'!
test06WhenListACartShouldHaveAllAddedElements

	|aCart aProduct otherProduct productsAdded aCatalog|
	
	aCatalog := self aCatalogNotEmpty.
	
	aProduct  := self aProductInTheCatalog .
	otherProduct  := self otherProductInTheCatalog .
	
	aCart := Cart newWithCatalog: aCatalog.
	aCart addProduct: aProduct .
	aCart addProduct: otherProduct .

	productsAdded := (Array with: aProduct with: otherProduct ) .

	(aCart products) do: [ :aProductList | self assert: (productsAdded includes: aProductList)].! !

!TusLibrosTest methodsFor: 'cartTests' stamp: 'PaneroGomez 6/18/2012 00:38'!
test07AddingAProductSpecifingTheQuantityShouldAddTheRightAmountOfProducts

	|aCart aProduct aCatalog|
	
	aCatalog := self aCatalogNotEmpty.
	aProduct  := self aProductInTheCatalog .
	
	aCart := Cart newWithCatalog: aCatalog.
	aCart addProduct: aProduct quantity: 3.

	self assert: ( aCart products size = 3).! !

!TusLibrosTest methodsFor: 'cartTests' stamp: 'PaneroGomez 6/18/2012 00:38'!
test08AddingAProductSpecifingANegativeQuantityShouldRaiseAnError
	
	|aCart aProduct aCatalog|
	
	aCatalog := self aCatalogNotEmpty.
	aProduct  := self aProductInTheCatalog .
	
	aCart := Cart newWithCatalog: aCatalog.
	
	self 
		should: [aCart addProduct: aProduct quantity: -3.	]	 
		raise:  Error 
		withExceptionDo: [:anError | self assert: (anError messageText = Cart messageTextNegativeQuantityError) ].
		
	self assert: (aCart size = 0).! !

!TusLibrosTest methodsFor: 'cartTests' stamp: 'PaneroGomez 6/19/2012 20:44'!
test09AddingAProducThatIsNotInTheCatalogShouldRaiseAnError
	
	|aCart otherProduct aCatalog|
	
	otherProduct  := self aProductNotInTheCatalog.
	
	aCatalog := self aCatalogEmpty.
	
	aCart := Cart newWithCatalog: aCatalog.
	
	self 
		should: [aCart addProduct: otherProduct.	]	 
		raise:  Error 
		withExceptionDo: [:anError | self assert: (anError messageText = Cart messageTextGivenBookDontBelongToTheCatalog) ].
		
	self assert: (aCart size = 0).! !

!TusLibrosTest methodsFor: 'cashierTests' stamp: 'ExequielGomez 6/22/2012 23:37'!
test10GivenAnEmptyCartWhenTryingToCheckOutShouldRaiseAnException

	| aCart aCashier aCreditCard currentMonth cashAvailableBeforeCheckOut productsBeforeCheckOut salesBookBeforeCheckOut amountOfTransactionsBeforeCheckOut|
	
	currentMonth := Month current.
	
	aCart := Cart newWithCatalog: (self aCatalogEmpty).
	aCashier := Cashier newWithMerchantProcesorInterface: (MerchantProcessorInternalInterfaceStub newWithSuccesfulTransaction).
	aCreditCard := CreditCard ownedBy: 'Pepe' identifiedBy: 123456789 expiresOn: (MonthOfYear onMonthNumber: currentMonth month of: currentMonth year).
	
	productsBeforeCheckOut := aCart products.
	cashAvailableBeforeCheckOut := aCashier cashAvailable.
	salesBookBeforeCheckOut := aCashier salesBook.
	amountOfTransactionsBeforeCheckOut := aCashier merchantProcessorInternalInterface amountOfTransactions.
	
	self 
		should: [ aCashier checkOutWith: aCart usingCreditCard: aCreditCard ]	 
		raise:  Error 
		withExceptionDo: [
			:anError | 	self assert: (anError messageText = Cashier messageTextTheCartMustNotBeEmpty).						
						self givenAFinalCart: aCart andAFinalCashier: aCashier shouldHaveTheProducts: productsBeforeCheckOut andTheCash: cashAvailableBeforeCheckOut andTheSalesBook: salesBookBeforeCheckOut andAnAmountOfTransactionsShouldBe: amountOfTransactionsBeforeCheckOut.
		].! !

!TusLibrosTest methodsFor: 'creditCardTests' stamp: 'ExequielGomez 6/22/2012 23:37'!
test11aGivenAnExpiredCreditCardWhenTryingToCheckOutShouldRaiseAnException

    | currentDate cashAvailableBeforeCheckOut salesBookBeforeCheckOut aCart aCashier anExpiredCreditCard expiredDateWithAnOlderMonth  productsBeforeCheckOut amountOfTransactionsBeforeCheckOut |
   
    currentDate := Date current.
   
    aCashier := Cashier newWithMerchantProcesorInterface: (MerchantProcessorInternalInterfaceStub newWithSuccesfulTransaction).
    cashAvailableBeforeCheckOut  := aCashier cashAvailable.
   
    aCart := Cart newWithCatalog: (self aCatalogNotEmpty).
    aCart addProduct: (self aProductInTheCatalog) quantity: 2.
   
	expiredDateWithAnOlderMonth := MonthOfYear onMonthNumber: (currentDate month - 1) of: (currentDate year).
       
	anExpiredCreditCard := CreditCard ownedBy: 'Pepe' identifiedBy: 123456789 expiresOn: expiredDateWithAnOlderMonth.
   
	productsBeforeCheckOut := aCart products.
	salesBookBeforeCheckOut := (aCashier salesBook) copy.
	amountOfTransactionsBeforeCheckOut := (aCashier merchantProcessorInternalInterface) amountOfTransactions.

    self
        should: [ aCashier checkOutWith: aCart usingCreditCard: anExpiredCreditCard ]
        raise:  Error
        withExceptionDo: [:anError |
	                                    self assert: (anError messageText = Cashier messageTextTheCreditCardHasExpired).
 	                                    self givenAFinalCart: aCart 
								 andAFinalCashier: aCashier 
								 shouldHaveTheProducts:  productsBeforeCheckOut 
								 andTheCash: cashAvailableBeforeCheckOut 
								 andTheSalesBook: salesBookBeforeCheckOut 
								 andAnAmountOfTransactionsShouldBe: amountOfTransactionsBeforeCheckOut.
                            		].! !

!TusLibrosTest methodsFor: 'creditCardTests' stamp: 'PaneroGomez 6/24/2012 20:13'!
test11bGivenAStolenCreditCardWhenTryingToCheckOutShouldRaiseAnException

	| aCart aCashier aCreditCard expirationDate currentDate cashAvailableBeforeCheckOut salesBookBeforeCheckOut productsBeforeCheckOut amountOfTransactionsBeforeCheckOut |
	
	"set up"
	aCashier := Cashier newWithMerchantProcesorInterface: (MerchantProcessorInternalInterfaceStub newWithFailedTransactionForAStolenCreditCard).
	aCart := Cart newWithCatalog: (self aCatalogNotEmpty).
	aCart addProduct: (self aProductInTheCatalog) quantity: 2.
	currentDate := Date current.
	expirationDate := MonthOfYear onMonthNumber: (currentDate month) of: (currentDate year).
	aCreditCard := CreditCard ownedBy: 'Pepe' identifiedBy: 123456789 expiresOn: expirationDate.
	
	"take a snapshot "
	cashAvailableBeforeCheckOut  := aCashier cashAvailable.
	productsBeforeCheckOut := aCart products.
	salesBookBeforeCheckOut := aCashier salesBook.
	amountOfTransactionsBeforeCheckOut := (aCashier merchantProcessorInternalInterface) amountOfTransactions.

    self
        should: [ aCashier checkOutWith: aCart usingCreditCard: aCreditCard ]
        raise:  Error
        withExceptionDo: [:anError |
									self assert: (anError messageText = MerchantProcessorInternalInterface messageTextTheCreditCardWasStolen).
									self givenAFinalCart: aCart 
										 andAFinalCashier: aCashier 
										 shouldHaveTheProducts:  productsBeforeCheckOut 	
										 andTheCash: cashAvailableBeforeCheckOut 
										 andTheSalesBook: salesBookBeforeCheckOut 
										 andAnAmountOfTransactionsShouldBe: (amountOfTransactionsBeforeCheckOut + 1).
						].! !

!TusLibrosTest methodsFor: 'creditCardTests' stamp: 'ExequielGomez 6/22/2012 23:50'!
test11cGivenACreditCardWithNoFoundsWhenTryingToCheckOutShouldRaiseAnException

	| currentDate cashAvailableBeforeCheckOut   salesBookBeforeCheckOut aCart aCashier anCreditCard expirationDate  productsBeforeCheckOut amountOfTransactionsBeforeCheckOut |
	
	"set up"
	aCashier := Cashier newWithMerchantProcesorInterface: (MerchantProcessorInternalInterfaceStub newWithFailedTransactionForNoFounds).
	aCart := Cart newWithCatalog: (self aCatalogNotEmpty).
	aCart addProduct: (self aProductInTheCatalog) quantity: 2.
	currentDate := Date current.
	expirationDate := MonthOfYear onMonthNumber: (currentDate month) of: (currentDate year).
	anCreditCard := CreditCard ownedBy: 'Pepe' identifiedBy: 123456789 expiresOn: expirationDate.
	
	"take a snapshot "
	cashAvailableBeforeCheckOut := aCashier cashAvailable.
      productsBeforeCheckOut := aCart products.
      salesBookBeforeCheckOut := (aCashier salesBook) copy.
      amountOfTransactionsBeforeCheckOut := (aCashier merchantProcessorInternalInterface) amountOfTransactions.

	self 
		should: [ aCashier checkOutWith: aCart usingCreditCard: anCreditCard ]
		raise:  Error 
		withExceptionDo: [:anError | 
									self assert: (anError messageText = MerchantProcessorInternalInterface messageTextTheCreditCardHasNoFounds).
									self givenAFinalCart: aCart 
          				                               andAFinalCashier: aCashier  
       			                                     shouldHaveTheProducts:  productsBeforeCheckOut 
                                           			 andTheCash: cashAvailableBeforeCheckOut 
                                           			 andTheSalesBook: salesBookBeforeCheckOut 
										 andAnAmountOfTransactionsShouldBe: (amountOfTransactionsBeforeCheckOut+1).	
							].! !

!TusLibrosTest methodsFor: 'creditCardTests' stamp: 'PaneroGomez 6/24/2012 20:15'!
test11dGivenAValidCreditCardWhenTryingToCheckOut

	| currentDate cashAvailableBeforeCheckOut   salesBookBeforeCheckOut aCart aCashier expirationDate  productsBeforeCheckOut amountOfTransactionsBeforeCheckOut aProduct total    aCreditCard |
	
	"set up"
	aCashier := Cashier newWithMerchantProcesorInterface: (MerchantProcessorInternalInterfaceStub newWithSuccesfulTransaction).
	aProduct := self aProductInTheCatalog.
	aCart := Cart newWithCatalog: (self aCatalogNotEmpty).
	aCart addProduct: aProduct quantity: 2.
	currentDate := Date current.
	expirationDate := MonthOfYear onMonthNumber: (currentDate month) of: (currentDate year).
	aCreditCard := CreditCard ownedBy: 'Pepe' identifiedBy: 123456789 expiresOn: expirationDate.
	
	"take a snapshot "
	cashAvailableBeforeCheckOut := aCashier cashAvailable.
      productsBeforeCheckOut := aCart products.
      salesBookBeforeCheckOut := (aCashier salesBook) copy.
      amountOfTransactionsBeforeCheckOut := (aCashier merchantProcessorInternalInterface) amountOfTransactions.

	total := aCashier checkOutWith: aCart usingCreditCard: aCreditCard.
	
	self assert: aCart isEmpty.
									
	self assert: total = (2*(aProduct price)).
	
	self assert: ((cashAvailableBeforeCheckOut + (2 * aProduct price)) = aCashier cashAvailable).
	
	self assert: aCashier salesBook size = ((salesBookBeforeCheckOut size) + 1).
	
	self saleBookOf: aCashier shouldBeLike: salesBookBeforeCheckOut andContainTheNewProducts: productsBeforeCheckOut boughtWith: (aCreditCard number).
	
	self assert: (amountOfTransactionsBeforeCheckOut + 1) = aCashier merchantProcessorInternalInterface amountOfTransactions.
! !

!TusLibrosTest methodsFor: 'creditCardTests' stamp: 'PaneroGomez 6/26/2012 20:37'!
test12GivenAValidUserAndPasswordWhenCreateACartSholdReturnTheCartId

	| restInterface aValidClientID aValidPassword aUserAdministrator response |
	
	aUserAdministrator := self userAdministrator.

	aValidClientID := aUserAdministrator clients at: 1.
	aValidPassword := aUserAdministrator passwordOf: aValidClientID.
		
	restInterface := RestInternalInterface newWithUserAdministrator: aUserAdministrator withCatalog: (self aCatalogNotEmpty) withCartManager: (self cartManager) andAClock: Clock new.
	
	response := restInterface createCartWith: aValidClientID andPassword: aValidPassword .
	
	self assert: ('0|*' match: response).
	
	! !

!TusLibrosTest methodsFor: 'creditCardTests' stamp: 'PaneroGomez 6/26/2012 20:39'!
test13aGivenAValidCartIdAProductIdAndAQuantityWhenAddingToTheCartShouldAddTheProductsToTheCart

	| aValidCartId aProductId aQuantity aCart aCartManager restInterface response aClock |
	
	aCart := Cart newWithCatalog: (self aCatalogNotEmpty).
	aProductId := (self aProductInTheCatalog) itemID.
	
	aClock := Clock new.
	
	aCartManager := self cartManager.
	aValidCartId := aCartManager addCart: aCart withTimestamp: (aClock currentTime).
	
	restInterface := RestInternalInterface newWithUserAdministrator: (self userAdministrator) withCatalog: (self aCatalogNotEmpty) withCartManager: aCartManager andAClock: aClock.
	
	response := restInterface addToCart: aValidCartId theProdcut: aProductId quantity: 2.
		
	self assert: ('0|*' match: response).
	
	! !

!TusLibrosTest methodsFor: 'creditCardTests' stamp: 'PaneroGomez 6/27/2012 19:14'!
test13bGivenAValidCartIdAProductIdAndAQuantityWhenAddingToACartWithALifeTimeGreaterThan30MinutesShouldRaiseAnException

	| aValidCartId aProductId aQuantity aCart aCartManager restInterface response aClock |
	
	aCart := Cart newWithCatalog: (self aCatalogNotEmpty).
	aProductId := (self aProductInTheCatalog) itemID.
	
	aClock := Clock new.
	
	aCartManager := self cartManager.
	aValidCartId := aCartManager addCart: aCart withTimestamp: (aClock currentTime).
	
	aClock updateClock: (DateAndTime fromSeconds: ((aClock currentTime asSeconds) + (30 * 60))).
	
	restInterface := RestInternalInterface newWithUserAdministrator: (self userAdministrator) withCatalog: (self aCatalogNotEmpty) withCartManager: aCartManager andAClock: aClock.
	
	response := restInterface addToCart: aValidCartId theProdcut: aProductId quantity: 2.
		
	self assert: (('1|', CartManager messageTextTheCartLifeTimeIsExpired) match: response).! !

!TusLibrosTest methodsFor: 'creditCardTests' stamp: 'ExequielGomez 6/27/2012 00:01'!
test14aGivenAValidCartIdWhenListCartShouldListTheCart

	| aValidCartId aProductId aQuantity aCart aCartManager restInterface response aClock |
	
	aCart := Cart newWithCatalog: (self aCatalogNotEmpty).
	aProductId := (self aProductInTheCatalog) itemID.
	
	aClock := Clock new.
	
	aCartManager := self cartManager.
	aValidCartId := aCartManager addCart: aCart withTimestamp: (aClock currentTime).
	
	restInterface := RestInternalInterface newWithUserAdministrator: (self userAdministrator) withCatalog: (self aCatalogNotEmpty) withCartManager: aCartManager andAClock: aClock.
	
	restInterface addToCart: aValidCartId theProdcut: aProductId quantity: 2.
	response := restInterface listCart: aValidCartId.
	
	self assert: (('0|', aProductId , '|2') = response).
! !

!TusLibrosTest methodsFor: 'creditCardTests' stamp: 'ExequielGomez 6/27/2012 00:23'!
test14bGivenAValidCartIdWhenListCartWithALifeTimeGreaterThan30MinutesShouldRaiseAnException

	| aCartId aProductId aQuantity aCart aCartManager restInterface response aClock |
	
	aCart := Cart newWithCatalog: (self aCatalogNotEmpty).
	aProductId := (self aProductInTheCatalog) itemID.
	
	aClock := Clock new.
	
	aCartManager := self cartManager.
	aCartId := aCartManager addCart: aCart withTimestamp: (aClock currentTime).
	
	restInterface := RestInternalInterface newWithUserAdministrator: (self userAdministrator) withCatalog: (self aCatalogNotEmpty) withCartManager: aCartManager andAClock: aClock.
	
	restInterface addToCart: aCartId theProdcut: aProductId quantity: 2.

	aClock updateClock: (DateAndTime fromSeconds: ((aClock currentTime asSeconds) + (30 * 60))).
	
	response := restInterface listCart: aCartId.
		
	self assert: (('1|', CartManager messageTextTheCartLifeTimeIsExpired) = response).! !

!TusLibrosTest methodsFor: 'creditCardTests' stamp: 'ExequielGomez 6/27/2012 00:26'!
test14cGivenAInValidCartIdWhenListCartShouldListTheCartShouldRaiseAnException

	| aValidCartId aProductId aQuantity aCart aCartManager restInterface response aClock |
	
	aCart := Cart newWithCatalog: (self aCatalogNotEmpty).
	aProductId := (self aProductInTheCatalog) itemID.
	
	aClock := Clock new.
	
	aCartManager := self cartManager.
	aValidCartId := aCartManager addCart: aCart withTimestamp: (aClock currentTime).
	
	restInterface := RestInternalInterface newWithUserAdministrator: (self userAdministrator) withCatalog: (self aCatalogNotEmpty) withCartManager: aCartManager andAClock: aClock.
	
	restInterface addToCart: aValidCartId theProdcut: aProductId quantity: 2.
	response := restInterface listCart: '123445'.
	
	self assert: (('1|', CartManager messageTextTheCartDoesNotExists) = response).
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 18:44'!
userAdministrator
	
	|  aUserAdministrator |
	
	aUserAdministrator := UsersAdministrator new.
	aUserAdministrator addUserId: 'pepe' withPassword: 'pepe0001'.
	aUserAdministrator addUserId: 'papo' withPassword: 'papo0001'.
	
	^ aUserAdministrator.
	


	
	! !

Object subclass: #Cart
	instanceVariableNames: 'products catalog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cart class methodsFor: 'message handling' stamp: 'PaneroGomez 6/24/2012 21:21'!
messageTextCartLifeTimeExpired
	
	^ 'The cart have been inactive for more than 30 minutes'.! !

!Cart class methodsFor: 'message handling' stamp: 'PaneroGomez 6/16/2012 16:31'!
messageTextGivenBookDontBelongToTheCatalog
	
	^ 'The given product doesnt belong to the catalog'.! !

!Cart class methodsFor: 'message handling' stamp: 'ExeNico 6/13/2012 21:35'!
messageTextNegativeQuantityError

	^ 'Quantity must be greater than zero'! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'ExeNico 6/13/2012 21:44'!
newWithCatalog: aCatalog

	^ self new initializeWith: aCatalog.! !

!Cart methodsFor: 'updating' stamp: 'ExeNico 6/13/2012 21:45'!
addProduct: aProduct
 	
	self addProduct: aProduct quantity: 1.! !

!Cart methodsFor: 'updating' stamp: 'PaneroGomez 6/26/2012 19:27'!
addProduct: aProduct quantity: anAmount 
 	
	(anAmount <= 0)
		ifTrue: [
			self error: self class messageTextNegativeQuantityError.
		].
	
	(catalog includesKey: (aProduct itemID))
		ifFalse: [
			self error: self class messageTextGivenBookDontBelongToTheCatalog.		
		].
	
	products add: aProduct withOccurrences: anAmount. ! !

!Cart methodsFor: 'accessing' stamp: 'GomezPanero 6/25/2012 21:44'!
catalog

	^ catalog copy.! !

!Cart methodsFor: 'updating' stamp: 'GomezPanero 6/25/2012 21:46'!
cleanCurrentProducts

	products removeAll.! !

!Cart methodsFor: 'initializing' stamp: 'GomezPanero 6/25/2012 21:45'!
initializeWith: aCatalog

	catalog := aCatalog.
	products := Bag new.! !

!Cart methodsFor: 'comparing' stamp: 'GomezPanero 6/25/2012 21:45'!
isEmpty

	^ products isEmpty.! !

!Cart methodsFor: 'accessing' stamp: 'GomezPanero 6/25/2012 21:44'!
products

	^ products copy.! !

!Cart methodsFor: 'accessing' stamp: 'GomezPanero 6/25/2012 21:45'!
quantityOf: aProduct

	^ self products occurrencesOf: aProduct.! !

!Cart methodsFor: 'comparing' stamp: 'GomezPanero 6/25/2012 21:45'!
size
	
	^ products size.! !

Object subclass: #CartManager
	instanceVariableNames: 'carts cartsTimestamps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!CartManager class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 19:38'!
messageTextTheCartDoesNotExists

	^ 'The id provided doesnt match any existing Cart'.! !

!CartManager class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 20:51'!
messageTextTheCartLifeTimeIsExpired

	^ 'The Cart has reached the expiration time'.! !

!CartManager methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 20:09'!
addCart: aCart withTimestamp: dateAndTime

	| cartId |
	
	cartId := (carts size) printString.
	carts at: cartId  put: aCart .
	cartsTimestamps at: cartId put: dateAndTime.
	
	^ cartId .
	! !

!CartManager methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 19:37'!
getCart: aCartId

	(carts includesKey: aCartId)
		ifFalse:[
			self error: self class messageTextTheCartDoesNotExists.
		].
	
	^ carts at: aCartId.! !

!CartManager methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 20:38'!
initialize

	carts := Dictionary new.
	cartsTimestamps := Dictionary new.! !

!CartManager methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 21:04'!
verifyExpirationOfTheCart: aCartId onTime: currentDateAndTime

	| lastDateAndTime |
	
	lastDateAndTime := cartsTimestamps at: aCartId.
	
	(currentDateAndTime asSeconds - lastDateAndTime asSeconds) < (30 * 60)
		ifFalse: [
			self error: self class messageTextTheCartLifeTimeIsExpired.
		].! !

Object subclass: #Cashier
	instanceVariableNames: 'salesBook cashAvailable merchantProcessorInternalInterfaceStub'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Cashier class methodsFor: 'error handling' stamp: 'PaneroGomez 6/16/2012 17:34'!
messageTextTheCartMustNotBeEmpty
	
	^ 'The Cart should have any products in order to check out'.! !

!Cashier class methodsFor: 'error handling' stamp: 'PaneroGomez 6/19/2012 19:37'!
messageTextTheCreditCardHasExpired
	
	^ 'The credit card provided has expired'.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/19/2012 20:39'!
newWithMerchantProcesorInterface: aMPInterface
	
	^ self new initializeWithMerchantProcesorInterface: aMPInterface.! !

!Cashier methodsFor: 'private' stamp: 'ExequielGomez 6/20/2012 17:35'!
addSale: saleDescirption for: aCreditCard

	|salesOfTheClient|
	salesOfTheClient := self saleOf: (aCreditCard number).
	salesOfTheClient add: saleDescirption.
	salesBook at: (aCreditCard number)  put: salesOfTheClient.
	

	! !

!Cashier methodsFor: 'accessing' stamp: 'PaneroGomez 6/19/2012 20:16'!
cashAvailable 

	^ cashAvailable copy.! !

!Cashier methodsFor: 'updating' stamp: 'ExequielGomez 6/22/2012 23:48'!
checkOutWith: aCart usingCreditCard: aCreditCard

	| transactionResult productsAndItsQuantities saleDescirption|

	(aCart size  <= 0)
		ifTrue: [
			self error: self class messageTextTheCartMustNotBeEmpty.
		].
	
	(aCreditCard isExpiredOn: (MonthOfYear onMonthNumber: (Date current month) of: (Date current year)))
		ifTrue: [
			self error: self class messageTextTheCreditCardHasExpired.
		].

	saleDescirption := self saleDescriptionFor: (aCart products).
		
	transactionResult := merchantProcessorInternalInterfaceStub collect: (saleDescirption total) usingCreditCard: aCreditCard.
		
	(transactionResult isSuccesful)
			ifFalse: [
				self error: transactionResult message.
			].
	
	aCart cleanCurrentProducts.
	
	cashAvailable := cashAvailable +  (saleDescirption total).
	
	self addSale: saleDescirption for: aCreditCard.
	
	^ (saleDescirption total).! !

!Cashier methodsFor: 'initializing' stamp: 'PaneroGomez 6/22/2012 20:37'!
initializeWithMerchantProcesorInterface: aMPInterface 
	
	cashAvailable := 0.
	merchantProcessorInternalInterfaceStub := aMPInterface.
	salesBook := Dictionary new.! !

!Cashier methodsFor: 'accessing' stamp: 'ExequielGomez 6/22/2012 23:37'!
merchantProcessorInternalInterface

	^ merchantProcessorInternalInterfaceStub copy.! !

!Cashier methodsFor: 'private' stamp: 'ExequielGomez 6/20/2012 17:39'!
saleDescriptionFor: products

	|total productsAndItsQuantities|
	total := 0.

	productsAndItsQuantities := Dictionary new.
	products do:[ :product | 
		                  |quantity|
					total := total + (product price). 
					quantity := productsAndItsQuantities at:  (product itemID) ifAbsentPut: [ 0].
					productsAndItsQuantities at:  (product itemID) put: (quantity+1).					
				].
	^ Sale newWithTotal: total  andProductsAndItsQuantities: productsAndItsQuantities.
		
! !

!Cashier methodsFor: 'accessing' stamp: 'ExequielGomez 6/20/2012 17:39'!
saleOf: creditCardNumber

	^ salesBook at: creditCardNumber ifAbsentPut:[ OrderedCollection new].
	

	! !

!Cashier methodsFor: 'accessing' stamp: 'ExequielGomez 6/20/2012 17:07'!
salesBook 

	^ salesBook copy.! !

Object subclass: #Clock
	instanceVariableNames: 'currentTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Clock methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 20:11'!
currentTime

	^ currentTime.! !

!Clock methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 19:52'!
initialize

	currentTime := DateAndTime current.! !

!Clock methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 19:53'!
updateClock: aDateAndTime

	currentTime := aDateAndTime.! !

Object subclass: #MerchantProcessorInternalInterface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MerchantProcessorInternalInterface class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/22/2012 21:19'!
messageTextTheCreditCardHasNoFounds

	^ 'The credit card has no founds'.! !

!MerchantProcessorInternalInterface class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/22/2012 21:00'!
messageTextTheCreditCardWasStolen

	^ 'This is a stolen credit card and can not be use'.! !

MerchantProcessorInternalInterface subclass: #MerchantProcessorInternalInterfaceStub
	instanceVariableNames: 'transactionResult amountOfTransactions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!MerchantProcessorInternalInterfaceStub class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/22/2012 21:05'!
newWithFailedTransactionForAStolenCreditCard

	^self new initializeWithAnAmountOfTransactions: 0 andWithTransactionResult: (TransactionResult newFailedWithMessage: self messageTextTheCreditCardWasStolen).! !

!MerchantProcessorInternalInterfaceStub class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/22/2012 21:18'!
newWithFailedTransactionForNoFounds

	^self new initializeWithAnAmountOfTransactions: 0 andWithTransactionResult: (TransactionResult newFailedWithMessage: self messageTextTheCreditCardHasNoFounds ).! !

!MerchantProcessorInternalInterfaceStub class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/22/2012 21:04'!
newWithSuccesfulTransaction
	
	^self new initializeWithAnAmountOfTransactions: 0 andWithTransactionResult: (TransactionResult newSuccesful).! !

!MerchantProcessorInternalInterfaceStub methodsFor: 'accessing' stamp: 'PaneroGomez 6/22/2012 21:00'!
amountOfTransactions

	^ amountOfTransactions copy.! !

!MerchantProcessorInternalInterfaceStub methodsFor: 'updating' stamp: 'PaneroGomez 6/22/2012 21:00'!
collect: anAmountOfMoney usingCreditCard: aCreditCart

	amountOfTransactions  := amountOfTransactions + 1.
	
	^ transactionResult.! !

!MerchantProcessorInternalInterfaceStub methodsFor: 'initializing' stamp: 'PaneroGomez 6/22/2012 21:02'!
initializeWithAnAmountOfTransactions: anAmount andWithTransactionResult: aTransactionResult
	
	amountOfTransactions := anAmount.
	transactionResult := aTransactionResult.
	! !

Object subclass: #Product
	instanceVariableNames: 'itemID price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Product class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/18/2012 00:29'!
newWithAnID: anID andAPrice: aPrice

	^ self new initializeWithAnID: anID andAPrice: aPrice.! !

!Product methodsFor: 'comparing' stamp: 'PaneroGomez 6/18/2012 00:49'!
= otherProduct

	(otherProduct isKindOf: self class)
		ifFalse: [^ false].
	
	^ ( itemID = otherProduct itemID and: [price = otherProduct price] ).! !

!Product methodsFor: 'comparing' stamp: 'PaneroGomez 6/18/2012 00:43'!
hash

	^ itemID hash + price hash.! !

!Product methodsFor: 'initializing' stamp: 'PaneroGomez 6/18/2012 00:30'!
initializeWithAnID: anID andAPrice: aPrice

	itemID := anID.
	price := aPrice.! !

!Product methodsFor: 'accessing' stamp: 'PaneroGomez 6/18/2012 00:31'!
itemID

	^ itemID copy.! !

!Product methodsFor: 'accessing' stamp: 'PaneroGomez 6/18/2012 00:31'!
price

	^ price copy.! !

Object subclass: #RestInternalInterface
	instanceVariableNames: 'userAdministrator catalog cartManager clock cashier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!RestInternalInterface class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 19:45'!
newWithUserAdministrator: aUserAdministrator withCatalog: aCatalog withCartManager: aCartManager andAClock: aClock
	
	^ self new initializeWithUserAdministrator: aUserAdministrator withCatalog: aCatalog withCartManager: aCartManager andAClock: aClock.! !

!RestInternalInterface methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 21:10'!
addToCart: cartId theProdcut: productId quantity: aQuantity
	
	| aProduct |
	
	aProduct := catalog at: productId.
	
	^ self withCartId: cartId 
		    do:	[ :aCart |
					aCart addProduct: aProduct quantity: aQuantity.
					^ '0|OK'.
				].
	
	
	! !

!RestInternalInterface methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 20:09'!
createCartWith: clientId andPassword: password 

	| aCartId |
	
	[userAdministrator validateAUserName: clientId withAPassword: password]
		on: Error 
		do:
			[ :anEror |
						^ '1|' ,  (anEror messageText).
			].
	
	aCartId := cartManager addCart: (Cart newWithCatalog: catalog) withTimestamp: (clock currentTime).
	
	^ '0|' , aCartId.
	! !

!RestInternalInterface methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 19:45'!
initializeWithUserAdministrator: aUsersAdministrator withCatalog: aCatalog withCartManager: aCartManager andAClock: aClock

	catalog := aCatalog.
	userAdministrator := aUsersAdministrator.
	cartManager := aCartManager.
	clock := aClock.! !

!RestInternalInterface methodsFor: 'as yet unclassified' stamp: 'ExequielGomez 6/27/2012 00:19'!
listCart: cartID

	| response|
	
	 ^self withCartId: cartID 
		    do:  [ :aCart |
					response := '0|'.
					(aCart products asSet) do: [ :aProduct |
						response := response , (aProduct itemID) , '|' ,  ((aCart quantityOf: aProduct) printString) . 
					].
					^ response.
				].! !

!RestInternalInterface methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/26/2012 21:06'!
withCartId: cartId do: aBlock
	
	| aCart |
	
	[
		aCart := cartManager getCart: cartId.
		cartManager verifyExpirationOfTheCart: cartId onTime: (clock currentTime). 
	]
	on: Error 
	do:
		[ :anEror |
				^ '1|' ,  (anEror messageText).
		].
	
	^ aBlock value: aCart.! !

Object subclass: #Sale
	instanceVariableNames: 'total producsAndItsQuantities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!Sale class methodsFor: 'as yet unclassified' stamp: 'ExequielGomez 6/20/2012 17:43'!
newWithTotal: aTotal andProductsAndItsQuantities: aProducsAndItsQuantities
	
	^self new initializeWithTotal: aTotal andProductsAndItsQuantities: aProducsAndItsQuantities. ! !

!Sale methodsFor: 'comparing' stamp: 'ExequielGomez 6/23/2012 16:00'!
= otherSale

	(otherSale isKindOf: self class)
		ifFalse: [^ false].
		
	^ total = otherSale total and:[ producsAndItsQuantities = otherSale producsAndItsQuantities].! !

!Sale methodsFor: 'comparing' stamp: 'ExequielGomez 6/23/2012 15:53'!
contains: aProductBag

	^aProductBag allSatisfy: [ :product | (aProductBag occurrencesOf: product) = (self quantityOf: product)]! !

!Sale methodsFor: 'initializing' stamp: 'ExequielGomez 6/20/2012 17:42'!
initializeWithTotal:  aTotal andProductsAndItsQuantities: aProducsAndItsQuantities  
	total := aTotal.
	producsAndItsQuantities := aProducsAndItsQuantities .! !

!Sale methodsFor: 'accessing' stamp: 'ExequielGomez 6/23/2012 15:50'!
quantityOf: aProduct

	^ producsAndItsQuantities at: (aProduct itemID) ifAbsent:[0] .! !

!Sale methodsFor: 'accessing' stamp: 'ExequielGomez 6/20/2012 17:43'!
total
	
	^ total! !

Object subclass: #TransactionResult
	instanceVariableNames: 'message success'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TransactionResult class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/22/2012 21:05'!
newFailedWithMessage: aMessage

	^ self new initializeWithResult: false andMessage: aMessage.! !

!TransactionResult class methodsFor: 'as yet unclassified' stamp: 'GomezPanero 6/18/2012 20:50'!
newSuccesful
	
	^ self new initializeWithResult: true andMessage: ''.! !

!TransactionResult methodsFor: 'initializing' stamp: 'PaneroGomez 6/19/2012 20:32'!
initializeWithResult: aBoolean andMessage: aMessage 

	message := aMessage .
	success := aBoolean.! !

!TransactionResult methodsFor: 'accessing' stamp: 'PaneroGomez 6/22/2012 21:15'!
isSuccesful

	^ success copy.! !

!TransactionResult methodsFor: 'accessing' stamp: 'PaneroGomez 6/22/2012 21:15'!
message

	^ message copy.! !

Object subclass: #UsersAdministrator
	instanceVariableNames: 'register'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!UsersAdministrator class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/24/2012 21:01'!
messageTextInvalidPassword

	^ 'The password provided was not valid'.! !

!UsersAdministrator class methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/24/2012 21:01'!
messageTextUserNotFound

	^ 'The user provided was not found'.! !

!UsersAdministrator methodsFor: 'as yet unclassified' stamp: 'GomezPanero 6/25/2012 20:47'!
addUserId: aClientID withPassword: aPassword 
	
	register at: aClientID put: aPassword.
	! !

!UsersAdministrator methodsFor: 'as yet unclassified' stamp: 'GomezPanero 6/25/2012 20:48'!
clients
	
	^ register keys.! !

!UsersAdministrator methodsFor: 'as yet unclassified' stamp: 'PaneroGomez 6/24/2012 20:57'!
initialize

	register := Dictionary new.! !

!UsersAdministrator methodsFor: 'as yet unclassified' stamp: 'GomezPanero 6/25/2012 20:50'!
passwordOf: aClientId
 
	^ register at: aClientId  ifAbsent: [ self error: UsersAdministrator messageTextUserNotFound].! !

!UsersAdministrator methodsFor: 'as yet unclassified' stamp: 'GomezPanero 6/25/2012 21:23'!
validateAUserName: aName withAPassword: aPassword

	self assert: (register includesKey: aName) description: UsersAdministrator messageTextUserNotFound.
	self assert: ((register at: aName) = aPassword) description: UsersAdministrator messageTextInvalidPassword.
	^ true.! !
